/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "fatfs.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "micros.h"
#include "fatfs_sd.h"
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <math.h>
#include "microFFT.h"
#include <complex.h>

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

uint8_t buff_ADC1[256]={0};
uint8_t buff_ADC2[256]={0};
uint8_t buff_exp_TS_1[256]={0};
uint8_t buff_exp_TS_2[256]={0};
uint16_t temp_values[128]={0};
uint16_t temp_values1[128]={0};

#define FFT_samples             128      //This value MUST ALWAYS be a power of 2
#define FFT_samplingFrequency   12000
#define FFT_ampFactor           1.0f
float vReal[FFT_samples]={0.0};
float vImag[FFT_samples]={0.0};
float vReal1[FFT_samples]={0.0};
float vImag1[FFT_samples]={0.0};


//uint8_t vect[4]={0};
uint8_t Byte_0, Byte_1, Byte_2, Byte_3;



/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
SPI_HandleTypeDef hspi1;
SPI_HandleTypeDef hspi2;
DMA_HandleTypeDef hdma_spi1_rx;
DMA_HandleTypeDef hdma_spi1_tx;
DMA_HandleTypeDef hdma_spi2_rx;
DMA_HandleTypeDef hdma_spi2_tx;

UART_HandleTypeDef huart2;

/* USER CODE BEGIN PV */
double setDR(double DR);
void send_uart(char *string){
	uint8_t len=strlen(string);
	HAL_UART_Transmit(&huart2, (uint8_t *) string, len, 2000);}
char stringa[100];
double delta_q;

double analogValue[8];


// Constructor
void ADC_reset() {
    HAL_GPIO_WritePin(RESET_GPIO_Port, RESET_Pin,SET);
	HAL_GPIO_WritePin(RESET_GPIO_Port, RESET_Pin,RESET);
}

void AD7606_settings (void){
	HAL_GPIO_WritePin(SPI1_CS_GPIO_Port, SPI1_CS_Pin, SET);
    HAL_GPIO_WritePin(CNVST_GPIO_Port, CNVST_Pin, SET);
	HAL_GPIO_WritePin(RESET_GPIO_Port, RESET_Pin, RESET);
    ADC_reset();
}

// Resets the AD7606


// Computes and stores the quantization step of the AD7606 as a function of its dynamic range (10 V or 20 V)
double setDR(double DR) {
    double q = (double) DR/65535.0; // Quantization step
    return q;
}

// Read raw values from all 8 channels
// rawDataBuffer is a pointer to an array of 8 16-bit integers
void readRAW(uint8_t *pointer, uint8_t *pointer1) {

	uint8_t lowByte, highByte;
	uint8_t dummy=0x00;
    HAL_GPIO_WritePin(CNVST_GPIO_Port , CNVST_Pin,0);  // Pulse CONVSTA/CONVSTB to start conversion
    //send_uart("SONO QUI\n\r");
    delay_10ns(3);
	HAL_GPIO_WritePin(CNVST_GPIO_Port, CNVST_Pin, 1);
    while (HAL_GPIO_ReadPin(BUSY_GPIO_Port, BUSY_Pin)==1) {
        // wait for conversions to be completed (low level on BUSY)

    }
    HAL_GPIO_WritePin(SPI1_CS_GPIO_Port, SPI1_CS_Pin, RESET); // Enable DOUTA/DOUTB lines and shift-out the conversion results
    /*for (char k = 0;  k < 8; k++) {
        HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &highByte, 1);
        HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &lowByte, 1);
        *(rawDataBuffer + k) = (int16_t) ((highByte << 8) + lowByte);
    }*/
    HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &highByte, 1);
    *(pointer)=highByte;
    HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &lowByte, 1);
    *(pointer+1)=lowByte;
	HAL_GPIO_WritePin(SPI1_CS_GPIO_Port,SPI1_CS_Pin, SET);
	//Read from the ADC2
	HAL_GPIO_WritePin(SPI1_CS2_GPIO_Port, SPI1_CS2_Pin, RESET);
	HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &highByte, 1);
	*(pointer1)=highByte;
	HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &lowByte, 1);
	*(pointer1+1)=lowByte;
	HAL_GPIO_WritePin(SPI1_CS2_GPIO_Port, SPI1_CS2_Pin, SET);
}

// Read analog values from all 8 channels
// analogDataBuffer is a pointer to an array of 8 doubles
void readAnalog(double *analogData,double *analogData1) {
	uint8_t lowByte, highByte;
	uint8_t dummy=0x00;
	HAL_GPIO_WritePin(CNVST_GPIO_Port, CNVST_Pin, 0);  // Pulse CONVSTA/CONVSTB to start conversion
    delay_10ns(3);
	HAL_GPIO_WritePin(CNVST_GPIO_Port, CNVST_Pin, 1);
    while (HAL_GPIO_ReadPin(BUSY_GPIO_Port,BUSY_Pin)==1) {
        // wait for conversions to be completed (low level on BUSY)

    }
   HAL_GPIO_WritePin(SPI1_CS_GPIO_Port,SPI1_CS_Pin, 0); // Enable DOUTA/DOUTB lines and shift-out the conversion results
    //for (char k = 0;  k < 8; k++) {
   HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &highByte, 1);
   HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &lowByte, 1);
        //*(analogDataBuffer + k) = (double)((int16_t) ((highByte << 8) + lowByte))*(10.0/65536);
   *(analogData) = (double)((int16_t) ((highByte << 8) + lowByte))*(10.0/65536);
    //}
	HAL_GPIO_WritePin(SPI1_CS_GPIO_Port,SPI1_CS_Pin, 1);
	// Read from ADC2
	HAL_GPIO_WritePin(SPI1_CS2_GPIO_Port,SPI1_CS2_Pin, 0); // Enable DOUTA/DOUTB lines and shift-out the conversion results
	    //for (char k = 0;  k < 8; k++) {
	HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &highByte, 1);
	HAL_SPI_TransmitReceive_DMA(&hspi1, &dummy, &lowByte, 1);
	        //*(analogDataBuffer + k) = (double)((int16_t) ((highByte << 8) + lowByte))*(10.0/65536);
	*(analogData1) = (double)((int16_t) ((highByte << 8) + lowByte))*(10.0/65536);
	    //}
	HAL_GPIO_WritePin(SPI1_CS2_GPIO_Port,SPI1_CS2_Pin, 1);


}

/*uint8_t* decompose_uint32 (uint32_t value){
vect[0]=(value&0x000000FF);
vect[1]=(value&0x0000FF00)>>8;
vect[2]=(value&0x00FF0000)>>16;
vect[3]=(value&0xFF000000)>>24;
return vect;
}*/
void decompose_uint32 (uint32_t value){
Byte_0=(value&0x000000FF);
Byte_1=(value&0x0000FF00)>>8;
Byte_2=(value&0x00FF0000)>>16;
Byte_3=(value&0xFF000000)>>24;
}
uint32_t compose (uint8_t b0,uint8_t b1,uint8_t b2,uint8_t b3){

return (uint32_t)(b3<<24)+(b2<<16)+(b1<<8)+b0;
}

// ..............................................................................
#define MAX_PAGES 0x7FFF



#ifndef _W25Q_H
#define _W25Q_H


#define W25Q_SPI &hspi1


#define W25Q_SPI_NOP            0xFF

#define W25Q_PORT     GPIOA


#define W25Q_PIN      GPIO_PIN_1


#define W25Q_CS_LO() HAL_GPIO_WritePin(W25Q_PORT, W25Q_PIN, GPIO_PIN_RESET);

#define W25Q_CS_HI() HAL_GPIO_WritePin(W25Q_PORT, W25Q_PIN, GPIO_PIN_SET);



#define W25Q_MAMORY_8           0x4014 // 1��
#define W25Q_MAMORY_16          0x4015 // 2��
#define W25Q_MAMORY_32          0x4017 // 4��


#define W25Q_WINBOND            0xEF // Winbond


#define W25Q_PAGE_LEN           256

#define W25Q_SECTOR_4           0x04


#define W25Q_BLOCK_64           0x40


#define W25Q_PAGE_8             0x0FFF
#define W25Q_PAGE_16            0x1FFF
#define W25Q_PAGE_32            0x7FFF


#define W25Q_WRITE_ENABLE       0X06
#define W25Q_WRRITE_DISABLE     0X04
#define W25Q_RD_STATUS_1        0x05
#define W25Q_RD_STATUS_2        0x35
#define W25Q_WR_STATUS          0x01
#define W25Q_PAGE_PROGRAM       0x02
#define W25Q_Q_PAGE_PROGRAM     0x32
#define W25Q_BLOCK_ERASE_64     0xD8
#define W25Q_BLOCK_ERASE_32     0x52
#define W25Q_SECTOR_ERASE_4     0x20
#define W25Q_CHIP_ERASE         0xC7
#define W25Q_ERASE_SUSPEND      0X75
#define W25Q_ERASE_RESUME       0x7A
#define W25Q_POWER_DOWN         0xB9
#define W25Q_HI_PF_MODE         0xA3
#define W25Q_MODE_BIT_RESET     0xFF
#define W25Q_RS_PWR_DOUN        0xAB
#define W25Q_MNF_DEVICE_ID      0x90
#define W25Q_RD_UNIQUE_ID       0x4B
#define W25Q_JEDEC_ID           0x9F
#define W25Q_READ_PAGE          0x0B

void w25qReadStatus(uint8_t *answer, uint8_t regnum);


void w25qWaitForReady(void);


void w25qSetBlockProtect(uint8_t protect);


void w25qReadManuf(uint8_t *answer);


void w25qReadPage(uint8_t *page, uint16_t pagenum);


void w25qWritePage(uint8_t *page, uint16_t pagenum);


void w25qEraseSector(uint16_t sector);

void w25qEraseChip(void);

#endif /* _W25Q_H */

void w25qReadStatus(uint8_t *answer, uint8_t regnum)
{
  W25Q_CS_LO();
  HAL_SPI_Transmit_DMA(W25Q_SPI, &regnum, 1);
  HAL_SPI_Receive_DMA(W25Q_SPI, answer, 1);
  W25Q_CS_HI();
}
//..................................................................................
void w25qWaitForReady(void)
{
  uint8_t reg = W25Q_RD_STATUS_1;
  uint8_t status = 0;

  W25Q_CS_LO();

  do
  {
    status = 0;

    W25Q_CS_LO();
    // �������� ������� ������ ���������� ��������
    HAL_SPI_Transmit(W25Q_SPI, &reg, 1,100);
    // ��������� ��������� �������
    HAL_SPI_Receive(W25Q_SPI, &status, 1,100);
    W25Q_CS_HI();
  }
  while (status & 0x01);


}

// ��������� �������� ���
void w25qSetBlockProtect(uint8_t protect)
{
  uint8_t temp[] = {0x50, 0x00};

  W25Q_CS_LO();
  HAL_SPI_Transmit(W25Q_SPI, temp, 1,100);
  W25Q_CS_HI();

  temp[0] = W25Q_WR_STATUS;
  temp[1] = ((protect & 0x0F) << 2);

  W25Q_CS_LO();
  HAL_SPI_Transmit(W25Q_SPI, temp, 2,100);
  W25Q_CS_HI();
}

// ������ ������ �� ����������
void w25qReadManuf(uint8_t *answer)
{
  // ������ ��� ������ �������
  uint8_t status = W25Q_JEDEC_ID;

  W25Q_CS_LO();
  // �������� �������
  HAL_SPI_Transmit(W25Q_SPI, &status, 1,100);
  // ��������� ���������
  HAL_SPI_Receive(W25Q_SPI, answer, 3,100);
  W25Q_CS_HI();
}

// ������ ��������
void w25qReadPage(uint8_t *page, uint16_t pagenum)
{
  // ������� ������ ��� �������
  uint8_t com[5] = {W25Q_READ_PAGE, (uint8_t)(pagenum >> 8),
                   (uint8_t)(pagenum & 0x00FF), 0x00, 0x00};

  W25Q_CS_LO();
  // �������� ������� � ����� ��������
  HAL_SPI_Transmit(W25Q_SPI, com, 5,100);
  // ��������� ��������
  HAL_SPI_Receive(W25Q_SPI, page, W25Q_PAGE_LEN,100);
  W25Q_CS_HI();
}

// ������ ��������
// � �������� ��������� ��������� ������ � �������
// ������� � �������� � ����� �������� ��� ������
void w25qWritePage(uint8_t *page, uint16_t pagenum)
{
  uint8_t temp[4] = {W25Q_WRITE_ENABLE, 0x00, 0x00, 0x00};

  w25qSetBlockProtect(0x00);

  W25Q_CS_LO();
  HAL_SPI_Transmit(W25Q_SPI, temp, 1,100);
  W25Q_CS_HI();

  temp[0] = W25Q_PAGE_PROGRAM;
  temp[1] = (uint8_t)(pagenum >> 8);
  temp[2] = (uint8_t)(pagenum & 0x00FF);
  temp[3] = 0x00;

  W25Q_CS_LO();
  HAL_SPI_Transmit(W25Q_SPI, temp, 4, 100);
  HAL_SPI_Transmit(W25Q_SPI, page, W25Q_PAGE_LEN,100);
  W25Q_CS_HI();

  w25qWaitForReady();

  temp[0] = W25Q_WRRITE_DISABLE;

  W25Q_CS_LO();
  HAL_SPI_Transmit(W25Q_SPI, temp, 1, 100);
  W25Q_CS_HI();

  w25qSetBlockProtect(0x0F);
}

// ������� �������
void w25qEraseSector(uint16_t sector)
{
  w25qSetBlockProtect(0x00);

  sector = (sector << 1);
  uint8_t com = W25Q_WRITE_ENABLE;
  uint8_t temp[4] = {W25Q_SECTOR_ERASE_4, (uint8_t)(sector >> 8),
                    (uint8_t)(sector & 0x00FF), 0x00};
  W25Q_CS_LO();
  // �������� ������� � ����� ��������
  HAL_SPI_Transmit(W25Q_SPI, &com, 1,100);
  W25Q_CS_HI();

  W25Q_CS_LO();
  // �������� ������� � ����� ��������
  HAL_SPI_Transmit(W25Q_SPI, temp, 4, 100);
  W25Q_CS_HI();

  w25qWaitForReady();

  temp[0] = W25Q_WRRITE_DISABLE;

  W25Q_CS_LO();
  HAL_SPI_Transmit(W25Q_SPI, temp, 1, 100);
  W25Q_CS_HI();

  w25qSetBlockProtect(0x0F);
}

// ������� ��� ������
void w25qEraseChip(void)
{
  w25qSetBlockProtect(0x00);

  uint8_t temp[3] = {W25Q_WRITE_ENABLE, W25Q_CHIP_ERASE, W25Q_WRRITE_DISABLE};

  W25Q_CS_LO();
  // �������� ������� � ����� ��������
  HAL_SPI_Transmit(W25Q_SPI, &temp[0], 1,100);
  W25Q_CS_HI();

  W25Q_CS_LO();
  // �������� ������� � ����� ��������
  HAL_SPI_Transmit(W25Q_SPI, &temp[1], 1, 100);
  W25Q_CS_HI();

  w25qWaitForReady();

  W25Q_CS_LO();
  // �������� ������� � ����� ��������
  HAL_SPI_Transmit(W25Q_SPI, &temp[2], 1, 100);
  W25Q_CS_HI();

  w25qSetBlockProtect(0x0F);
}
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_DMA_Init(void);
static void MX_SPI1_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_SPI2_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
FATFS fs;
FIL fil;
FIL fil2;
FRESULT fresult;
UINT br, bw;

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  uint16_t counterPage=0;
  uint16_t filecount=1;

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */
	float freq[128]={0};
	float delta_f=(float) FFT_samplingFrequency/FFT_samples;
	for(int i=0;i<FFT_samples;i++){
	freq[i]=(float)i*delta_f;
	}

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_SPI1_Init();
  MX_USART2_UART_Init();
  MX_SPI2_Init();
  MX_FATFS_Init();
  /* USER CODE BEGIN 2 */
  //uint8_t flag=1;
  DWT_Init();

  // FFT Initialization
  FFT_Init(vReal, vImag, FFT_samples, FFT_samplingFrequency);

  fresult=f_mount(&fs,"/",1);
  if (fresult != FR_OK)
  {
	  send_uart("Error in mounting SD Card ... \n");
  }
  else{
  send_uart("SD card mounted successfully \n");

  ADC_reset();
  uint32_t start_time=0;
  uint32_t prev_time=0; //previous time
  uint32_t time_stamp=0;

  send_uart("Erasing data in the external flash memory ... \n");
  w25qEraseChip();
  send_uart("Erasing Finished ... \n");
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  { sprintf(stringa,"data_%d.csv",filecount);
  	fresult=f_open(&fil,stringa,FA_CREATE_ALWAYS|FA_READ|FA_WRITE);
  	sprintf(stringa,"fft_%d.csv",filecount);
  	 fresult=f_open(&fil2,stringa,FA_CREATE_ALWAYS|FA_READ|FA_WRITE);
	send_uart("Press START button to begin acquisition\n\r");
    while(HAL_GPIO_ReadPin(START_GPIO_Port, START_Pin)){};
    send_uart("Acquisition Started.....\n\r");
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
    uint8_t data[2]={0,0};
    uint8_t data1[2]={0,0};
    HAL_GPIO_WritePin(STATUS_LED_GPIO_Port,STATUS_LED_Pin, 0);
    start_time=micros();

    while((HAL_GPIO_ReadPin(STOP_GPIO_Port, STOP_Pin)==1)&&(counterPage<=MAX_PAGES)){
        for(int j=0; j< 128; j++){
    	readRAW(data, data1);
    	//sprintf(stringa,"%d\t0x%02X\t0x%02X\n",j, data[0],data[1]);
    	//send_uart(stringa);
    	buff_ADC1[2*j]=data[0];
    	buff_ADC1[(2*j)+1]=data[1];
    	buff_ADC2[2*j]=data1[0];
    	buff_ADC2[(2*j)+1]=data1[1];
    	time_stamp=micros()-start_time;
    	//sprintf(stringa,"%lu\n\r",time_stamp);
    	//send_uart(stringa);
    	decompose_uint32(time_stamp);
    	if(j<64){
    	buff_exp_TS_1[4*j]=Byte_0;
    	buff_exp_TS_1[(4*j)+1]=Byte_1;
    	buff_exp_TS_1[(4*j)+2]=Byte_2;
    	buff_exp_TS_1[(4*j)+3]=Byte_3;
    	//sprintf(stringa,"0x%02X\t 0x%02X\t 0x%02X\t 0x%02X\n\r",buff_exp_TS_1[4*j],buff_exp_TS_1[(4*j)+1],buff_exp_TS_1[(4*j)+2],buff_exp_TS_1[(4*j)+3]);
    	//send_uart(stringa);
    	}
    	else{
    	buff_exp_TS_2[4*j-256]=Byte_0;
    	buff_exp_TS_2[((4*j)+1)-256]=Byte_1;
        buff_exp_TS_2[((4*j)+2)-256]=Byte_2;
        buff_exp_TS_2[((4*j)+3)-256]=Byte_3;
        //sprintf(stringa,"0x%02X\t 0x%02X\t 0x%02X\t 0x%02X\n\r",buff_exp_TS_2[(4*j)-256],buff_exp_TS_2[((4*j)+1)-256],buff_exp_TS_2[((4*j)+2)-256],buff_exp_TS_2[((4*j)+3)-256]);
        //send_uart(stringa);
    	}

        }
        //store time_stamp
        prev_time=micros();
        //if((counterPage%4)==0){
        //w25qEraseSector(counterPage);}
        w25qWritePage(buff_ADC1, counterPage);
        w25qWritePage(buff_ADC2, counterPage+1);
        w25qWritePage(buff_exp_TS_1, counterPage+2);

        /*if(flag==1){

        flag=0;
        w25qReadPage(buff_ADC1, 0);
        for(int i=0;i<128;i++){
        	sprintf(stringa,"0x%04X\n",(uint16_t) (buff_ADC1[2*i]<<8)+buff_ADC1[2*i+1]);
        	send_uart(stringa);
        }
        }*/
        w25qWritePage(buff_exp_TS_2, counterPage+3);
        counterPage+=4;
        start_time=start_time+(micros()-prev_time);//join acquired segment


    }

    send_uart("Acquisition Finished \n\r");
    HAL_GPIO_WritePin(STATUS_LED_GPIO_Port,STATUS_LED_Pin, 1);
    HAL_GPIO_WritePin(LED_SAVING_GPIO_Port, LED_SAVING_Pin, SET);

    for(uint32_t k=0; k<counterPage; k++){
    uint16_t m=k%4;

    switch(m){
    case 0:
    	//send_uart("CASO_0\n");
    	w25qReadPage(buff_ADC1, k);
    	for(uint8_t z=0;z<128;z++){
    		temp_values[z]=(int16_t)(buff_ADC1[2*z]<<8)+buff_ADC1[2*z+1];
    		vReal[z]=(float) temp_values[z]*(10.0/65536);
    	}

    	break;
    case 1:
    	//send_uart("CASO_1\n");
    	w25qReadPage(buff_ADC1, k);
    	for(uint8_t z=0;z<128;z++){
    		temp_values1[z]=(int16_t)(buff_ADC1[2*z]<<8)+buff_ADC1[2*z+1];
    		vReal1[z]=(float) temp_values1[z]*(10.0/65536);

    	}
    	break;
    case 2:
    	//send_uart("CASO_2\n");
    	w25qReadPage(buff_ADC1, k);
    	for(uint8_t z=0; z<64;z++){
    	uint32_t temp=compose(buff_ADC1[4*z],buff_ADC1[(4*z)+1],buff_ADC1[(4*z)+2],buff_ADC1[(4*z)+3]);
    	sprintf(stringa, "%lu, %f, %f\n",temp,(double) temp_values[z]*(10.0/65536), (double)temp_values1[z]*(10.0/65536));
    	fresult=f_write(&fil, stringa, strlen(stringa),&bw);
    	}
    	break;
    case 3:
    	//send_uart("CASO_3\n");
    	w25qReadPage(buff_ADC1, k);
    	for(uint8_t z=0; z<64;z++){
    	uint32_t temp=compose(buff_ADC1[4*z],buff_ADC1[(4*z)+1],buff_ADC1[(4*z)+2],buff_ADC1[(4*z)+3]);
    	sprintf(stringa, "%lu, %f, %f\n",temp,(double) temp_values[z+64]*(10.0/65536),(double) temp_values1[z+64]*(10.0/65536));
    	fresult=f_write(&fil, stringa, strlen(stringa),&bw);
    	}
    	break;
    }
    if(k==0){
    // FFT Calculation
    FFT_Windowing(FFT_WIN_TYP_HAMMING, FFT_FORWARD); // Recommended use for high frequencies. Relative to Sampling Frequency. In this case: 70Hz
    FFT_Compute(FFT_FORWARD);
    FFT_ComplexToMagnitude();
    }
    if(k==1){
    FFT_Init(vReal1, vImag1, FFT_samples, FFT_samplingFrequency);
    FFT_Windowing(FFT_WIN_TYP_HAMMING, FFT_FORWARD); // Recommended use for high frequencies. Relative to Sampling Frequency. In this case: 70Hz
    FFT_Compute(FFT_FORWARD);
    FFT_ComplexToMagnitude();
    }
    for(int z=0; z<128;z++){
        sprintf(stringa,"%f, %f, %f\n", freq[z], vReal[z],vReal1[z]);
        fresult=f_write(&fil2, stringa, strlen(stringa),&bw);}

 }
 send_uart("Save Complete.....\n\r");
 HAL_GPIO_WritePin(LED_SAVING_GPIO_Port, LED_SAVING_Pin, RESET);
 f_close(&fil);
 f_close(&fil2);
 counterPage=0;
 filecount++;
  }
 }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE2);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 25;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi1.Init.NSS = SPI_NSS_SOFT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_2;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief SPI2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI2_Init(void)
{

  /* USER CODE BEGIN SPI2_Init 0 */

  /* USER CODE END SPI2_Init 0 */

  /* USER CODE BEGIN SPI2_Init 1 */

  /* USER CODE END SPI2_Init 1 */
  /* SPI2 parameter configuration*/
  hspi2.Instance = SPI2;
  hspi2.Init.Mode = SPI_MODE_MASTER;
  hspi2.Init.Direction = SPI_DIRECTION_2LINES;
  hspi2.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi2.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi2.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi2.Init.NSS = SPI_NSS_SOFT;
  hspi2.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_2;
  hspi2.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi2.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi2.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi2.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI2_Init 2 */

  /* USER CODE END SPI2_Init 2 */

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 115200;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void)
{

  /* DMA controller clock enable */
  __HAL_RCC_DMA2_CLK_ENABLE();
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Stream3_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Stream3_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream3_IRQn);
  /* DMA1_Stream4_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Stream4_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream4_IRQn);
  /* DMA2_Stream0_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA2_Stream0_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA2_Stream0_IRQn);
  /* DMA2_Stream3_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA2_Stream3_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA2_Stream3_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(STATUS_LED_GPIO_Port, STATUS_LED_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, SPI1_CS_FLASH_Pin|SPI1_CS_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, CNVST_Pin|SPI1_CS2_Pin|SPI2_CS_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, RESET_Pin|LED_SAVING_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin : STATUS_LED_Pin */
  GPIO_InitStruct.Pin = STATUS_LED_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(STATUS_LED_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : SPI1_CS_FLASH_Pin SPI1_CS_Pin */
  GPIO_InitStruct.Pin = SPI1_CS_FLASH_Pin|SPI1_CS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : START_Pin STOP_Pin */
  GPIO_InitStruct.Pin = START_Pin|STOP_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : CNVST_Pin */
  GPIO_InitStruct.Pin = CNVST_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(CNVST_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : SPI1_CS2_Pin RESET_Pin LED_SAVING_Pin SPI2_CS_Pin */
  GPIO_InitStruct.Pin = SPI1_CS2_Pin|RESET_Pin|LED_SAVING_Pin|SPI2_CS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : BUSY_Pin */
  GPIO_InitStruct.Pin = BUSY_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(BUSY_GPIO_Port, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
